                /*ͻ
                  C Easy sampleg.c: Bouncing Graphics 
                 */

#include "\ceasy\ceasy1.h"       // required C Easy header files
#include "\ceasy\ceasy2.h"

main()
{
 char *buf;
 unsigned char *image, *image2;
 int row, column, x;

 start_program();

 set_graphics_mode(ON);
 clear_screen (BKGND_BLUE, FGND_BLUE);
 IGNORE_BLACK = ON;

 image = read_token ("c_easy.tok");
 put_token (image, 5, 130);
 free (image);
 image = get_image (TOKEN_WIDTH+10, TOKEN_HEIGHT+10, 1, 130);

 hide_cursor();
 BKGND_GUAGE   = BKGND_BLUE;
 FGND_GUAGE    = FGND_YELLOW;
 BKGND_GRAPHIC = FGND_BLUE;
 BKGND_CURSOR  = BKGND_BLUE;
 FGND_CURSOR   = FGND_BLUE;

 set_color (BKGND_BLUE);
 set_color (FGND_YELLOW);

 for (row=1,column=130,x=380; x; x--)
  {
   put_image (image, row++, column);
  }
 for (row=380,column=130,x=380; x; x--)
  {
   put_image (image, row--, column);
  }

 clear_screen (BKGND_GRAY, FGND_BLUE);

 for (row=1,column=130,x=300; x; x--)
  {
   if(row%8 == 0)
      display_guage ((long)row, (long)2*300, 70, 28, 6);
   put_image (image, row++, column);
  }

 if (kbhit()) exit_program();

 for (row=300,column=130,x=300; x; x--)
  {
   if(row%8 == 0)
     display_guage ((long)(300-row)+300, (long)2*300, 70, 28, 6);
   put_image (image, row--, column);
  }

 if (kbhit()) exit_program();

 clear_screen (BKGND_GRAY, FGND_BLUE);
 for (row=1,column=130,x=380; x; x--)
  {
   put_image (image, row++, column);
  }
 for (row=380,column=130,x=380; x; x--)
  {
   put_image (image, row--, column);
  }
 next_sample();
 return(0);
}

char *okay1ptr, *okay2ptr;
int next_sample()
{
 char *buf;

 BKGND_TIME = BKGND_BLACK;
 IGNORE_BLACK = OFF;
 clear_screen(BKGND_BLACK,FGND_BLACK);

 if(restore_combined("_soeasy.fvl") < 0)
  {
   display_error("Cannot open ","_soeasy.fvl");
  }

 okay1ptr=read_token("_okay1.tok");
 put_token(okay1ptr,274,250);
 okay2ptr=read_token("_okay2.tok");
 disable_time();
 show_mouse_cursor();
 check_okay(5,274,250);
 hide_mouse_cursor();
 if(restore_overlay("_cover.ovl",NULL)<0)
  {
   display_error("Cannot open ","_cover.ovl");
  }
 okay1ptr=read_token("_okay1.tok");
 put_token(okay1ptr,153,281);
 okay2ptr=read_token("_okay2.tok");
 disable_time();
 show_mouse_cursor();
 check_okay(6,153,281);
 ARROW=0;
 while(kbhit()) getch();
 hide_mouse_cursor();
 if(restore_overlay("_cezio.ovl",NULL)<0)
  {
   display_error("Cannot open ","_cezio.ovl");
  }
 okay1ptr=read_token("_okay1.tok");
 put_token(okay1ptr,460,281);
 okay2ptr=read_token("_okay2.tok");
 disable_time();
 show_mouse_cursor();
 check_okay(7,460,281);
 ARROW=0;
 while(kbhit()) getch();
 hide_mouse_cursor();
 if(restore_overlay("_formio.ovl",NULL)<0)
  {
   display_error("Cannot open ","_formio.ovl");
  }
 okay1ptr=read_token("_okay1.tok");
 put_token(okay1ptr,460,281);
 okay2ptr=read_token("_okay2.tok");
 disable_time();
 show_mouse_cursor();
 check_okay(7,460,281);
 ARROW=0;
 while(kbhit()) getch();
 set_graphics_mode(OFF);
 exit_program(0);
 return(0);
}

/* CHECK MOUSE POSITION */
int check_okay(spot,row,column)
int spot, row, column;
 {
  static int hotarray[][4]=
   {
    {37,51,60,78},
    {37,119,60,148},
    {37,195,60,221},
    {37,289,60,314},
    {274,250,296,325},
    {153,281,173,352},
    {450,281,479,352},
    {0,0,0,0}
   };
  int hotspot;

  while(1)
   {
    if(kbhit())
     {
      if(getch()==27)
       {
        break;
       }
     }
    if(mouse_button_down(LEFT_BUTTON) &&
       check_hotspots(hotarray,7)==spot)
     {
      hide_mouse_cursor();
      put_token(okay2ptr,row,column);
      show_mouse_cursor();
      while(mouse_button_down(LEFT_BUTTON) &&
          check_hotspots(hotarray,7)==spot);
      hotspot=check_hotspots(hotarray,7);
      if(hotspot==spot)
       {
        hide_mouse_cursor();
        put_token(okay2ptr,row,column);
        free(okay2ptr);
        show_mouse_cursor();
        break;
       }
      else
       {
        hide_mouse_cursor();
        put_token(okay1ptr,row,column);
        show_mouse_cursor();
       }
     }
   }
 return(0);
}

/*  CHECK MOUSE HOTSPOTS */
int check_hotspots(hot,maxhotspots)
int hot[][4];
int maxhotspots;
{
 int x;
 for(x=0;x<maxhotspots;x++)
  {
   get_mouse_position();
   if(MOUSE_ROW>hot[x][0] && MOUSE_ROW<hot[x][2]
      && MOUSE_COLUMN>hot[x][1] && MOUSE_COLUMN<hot[x][3]) return(x+1);
  }
 return(0);
}

int exit_program()
{
 while (kbhit()) getch();
 set_graphics_mode(OFF);
 stop_program();
 return (0);
}
